#!/bin/sh 
 
delete_instance_by_node()
{
	echo "delete_instance_by_node $1 $2" | tee -a $LOG_FILE

   INTOID=`echo "$2" | cut -d# -f1` 

   NAME=$1

	CO=`idlcall $CLO TMF_SysAdmin::Library::lookup_object ''\"$NAME\"' {0}'`
	if [ $? -eq 0 ] ; then
		members=`objcall $CO _get_members`
		
      #
      # filter members by node
      #
      
      for j in $members
		do
         OBLOC=`idlcall -T top $j get_resource_host`

         OBLOC=`echo "$OBLOC" | cut -d# -f1`

         if [ $OBLOC = $INTOID ] ; then
			   echo "Removing $NAME instance gently" | tee -a $LOG_FILE
			   idlcall -T top $j remove > /dev/null 2>&1
			   if [ $? -ne 0 ] ; then
				   echo "Removing $NAME instance forcefully" | tee -a $LOG_FILE

				   objcall $j _delete
			   fi
         fi
		done
	fi
}

delete_instance()
{
	NAME=$1
	CO=`idlcall $CLO TMF_SysAdmin::Library::lookup_object ''\"$NAME\"' {0}'`
	if [ $? -eq 0 ] ; then
		members=`objcall $CO _get_members`
		for j in $members
		do
			echo "Removing $NAME instance gently" | tee -a $LOG_FILE
			idlcall -T top $j remove > /dev/null 2>&1
			if [ $? -ne 0 ] ; then
				echo "Removing $NAME instance forcefully" | tee -a $LOG_FILE
				objcall $j _delete
			fi
		done
	fi
}

remove_presentation()
{
	echo "Removing presentaion object $1" | tee -a $LOG_FILE
	set +e
	PRES=`wlookup -r Presentation "$1#$IRONAME"`
   if [ ! -z "$PRES" ] ; then
      idlcall $PRES TMF_SysAdmin::PolicyDrivenBase::remove
   fi
   set -e
}

remove_class() 
{
   CO=`idlcall $CLO TMF_SysAdmin::Library::lookup_object ''\"$1\"' {0}'`
   if [ $? -ne 0 ] ; then
      continue
   fi
   
   #
   # Remove the class as a Managed Resource from all policy regions.
   #
   	
   echo "	Removing resource from Policy Regions"  | tee -a $LOG_FILE
   PRCO=`wlookup -r Classes PolicyRegion`
   regions=`objcall $PRCO _get_members`
   set +e
   for j in $regions
   do
      idlcall -T top $j TMF_Policy::Region::remove_instance_manager $CO 1> /dev/null 2>&1
   done
   set -e

   #
   # Remove any Presentation object
   #
   #set +e
   #PCO=`idlcall $CLO TMF_SysAdmin::Library::lookup_object ''\"Presentation\"' {0}'`
   #PO=`objcall $PCO _lookup_object $1`
   #if [ $? -eq 0 ] ; then
   #   echo "	Deleting Presentation Object gently" | tee -a $LOG_FILE
   #   idlcall -T top $PO remove > /dev/null 2>&1
   #   if [ $? -ne 0 ] ; then
   #      echo "	Deleting Presentation Object forcefully" | tee -a $LOG_FILE
   #      objcall $PO _delete
   #   fi
   #fi
   #set -e
   
   remove_presentation $1

	# Remove extention object
	EO=`idlattr -tg $CO extension Object | awk -F# '{print $1}'`
	if [ $? -eq 0 -a -n "$EO" -a "$EO" != "$CO" ];then
		objcall $EO rmobj
	fi

	#Remove the prototypes,
	PROTOTYPES=`idlattr -tg $CO prototypes TMF_Types::ObjectList`
	if [ -n "$PROTOTYPES" -a $? -eq 0 ];then	
		NUMPROTOS=`idlarg 1 $PROTOTYPES`
		COUNT=0
		ARG=2
		while [ $COUNT -ne $NUMPROTOS ]
		do
			OID=`idlarg $ARG $PROTOTYPES`
			objcall $OID rmobj
			COUNT=`expr $COUNT + 1`
			ARG=`expr $ARG + 1`
		done
	fi

   # Remove behavior object and update inheritency
	BO=`idlattr -tg $CO behavior Object`
        BO=`echo $BO | awk -F# '{print $1}'`
	case "$1" in 
          PCTarget|PCGateway)
		MNCO=`idlcall $CLO TMF_SysAdmin::Library::lookup_object '"ManagedNode" {0}'`
		MNBO=`idlattr -tg $MNCO behavior Object`
		objcall $MNBO oi_remove $BO
	    ;;
	    PCTplcf)
		PMNCO=`idlcall $CLO TMF_SysAdmin::Library::lookup_object '"PcManagedNode" {0}'`
		PMNBO=`idlattr -tg $PMNCO behavior Object`
		objcall $PMNBO oi_remove $BO
	    ;;
	    PCTlcf)
      	EPCO=`idlcall $CLO TMF_SysAdmin::Library::lookup_object '"Endpoint" {0}'`
      	EPBO=`idlattr -tg $EPCO behavior Object`
      	objcall $EPBO oi_remove $BO
	    ;;	
	esac

	# check to make sure the BO is not the same as CO
	if [ -n "$BO" -a "$BO" != "$CO" ];then
		objcall $BO rmobj
	fi

   # Remove the class object.  
	echo "Removing Class $1" | tee -a $LOG_FILE
	idlcall -T top $CO TMF_SysAdmin::InstanceManager::remove
   #
   # Clean out the name registry.
   #
   if [ "$1" = "RemoteControl" ]; then
      idlcall $TNR TMF_TNR::Resource::remove \"$1\" TRUE >> $LOG_FILE 2>&1
   fi
   set +e
   ISREG=`wlookup -r Classes $1 >> $LOG_FILE 2>&1 `
   if [ $? -eq 0 ];then
	wregister -u -r Classes $1
   elif wlookup -r distinguished $1 ; then
      wregister -u $1
   fi
   set -e
}

remove_role()
{     
     # remove roles from administrators
     # Admins=`wls -l /Library/Administrator | awk '{print $1}'`
     Admins=`wls -l /Library/Administrator | cut -d# -f1`

     for i in $Admins
     do
         #alias=`idlcall $i get_aliases | idlarg 2 | cut -d"\"" -f2`         
         alias=`idlcall $i get_aliases | idlarg 2 | tr -s "\"" " "`
         e_alias=`eval echo "$alias"`
         set +e
         groups=`objcall $REGION.0.0 get_principal_roles $e_alias | grep $1`
         if [ ! -z "$groups" ]
         then
            if [ "$groups" != "" ]  
            then         
               for j in $groups
               do
                   secgroup=`echo $j | sed 's/:/ /g'`
                   cnt=1
                   for k in $secgroup
                   do
                       if [ $cnt -eq 1 ]
                       then
                           newgrp=$k
                           cnt=`expr $cnt + 1 `
                       else
                           if [ "$k" != "$1" ]
                           then
                               newgrp="$newgrp $k"
                           fi
                       fi
                   done
                   newgrp="$newgrp "
                   dummy=`objcall $REGION.0.0 set_principal_roles $e_alias $newgrp`
               done
            fi
         fi
         chkgrp=`objcall $REGION.0.0 get_principal_roles $e_alias | grep $1`
         set -e
         if [ "$chkgrp" != "" ]
         then
           echo "Something went wrong" | tee -a $LOG_FILE
           echo "role = " $1
           echo "alias = " $alias
           echo "group = " $groups
           echo "secgroup = " $secgroup
           echo "new group = " $newgrp                     
         fi             
     done


     # Remove TMR roles and Resource roles
     #
     admin_coll=`wlookup Administrators`
     
     ROLES=`idlcall $admin_coll _get_supported_roles`

     if echo $ROLES | grep $1
     then
        COUNT=`echo $ROLES | idlarg 1`
        COUNT1=`expr $COUNT - 1`
        ROLES1=`echo $ROLES | sed 's/'"\"$1\""'//g'`
        ROLES=`echo $ROLES1 | sed 's/'"$COUNT"'/'"$COUNT1"'/g'`
        idlcall $admin_coll _set_supported_roles $ROLES
        #idlcall $admin_coll _set_supported_roles $ROLES1
     fi
     
     TMR_ROLES=`idlcall $admin_coll _get_supported_tmr_roles`
     if echo $TMR_ROLES | grep $1 
     then
        TCOUNT=`echo $TMR_ROLES | idlarg 1`
        TCOUNT1=`expr $TCOUNT - 1`     
        TMR_ROLES1=`echo $TMR_ROLES | sed 's/'"\"$1\""'//g'`
        TMR_ROLES=`echo $TMR_ROLES1 | sed 's/'"$TCOUNT"'/'"$TCOUNT1"'/g'`
        idlcall $admin_coll _set_supported_tmr_roles $TMR_ROLES     
        #idlcall $admin_coll _set_supported_tmr_roles $TMR_ROLES1
     fi   
}

update_ProductInfo()
{
	# removes the node from the ProductInfo and PatchInfo objects
	# related to the application.
	echo "Updating Product and Patch objects" | tee -a $LOG_FILE
	#PROD="$1"
   PROD="$1#$IRONAME"
	NODE="$2"
	PROD_IO=`wlookup -r ProductInfo "$PROD"`
	echo "prod_IO = " $PROD_IO
	PATCH_IOS=`idlcall $PROD_IO _get_patches`
	PROD_IO_VAL=`echo $PROD_IO|awk -F. '{print $2}'`
      if [ $PROD_IO_VAL -eq 1 ];then
		NUM=`idlarg 1 $PATCH_IOS`
		NUM=`expr "$NUM" + 2 `
		COUNT=2
		while [ "$COUNT" -lt "$NUM" ]
		do
			PATCH_IO=`idlarg $COUNT $PATCH_IOS`
   			idlcall $PATCH_IO remove_host_locations '{ 1' $NODE '}'
			COUNT=`expr "$COUNT" + 1 `
		done
		idlcall $PROD_IO remove_host_locations '{ 1' $NODE '}'
	fi
 

}
	
remove_ProductInfo()
{
   # Remove the product and patch installation objects
	echo "Removing Product and Patch objects" | tee -a $LOG_FILE
	#PROD="$1"
   PROD="$1#$IRONAME"
	PROD_IO=`wlookup -r ProductInfo "$PROD"`
	PATCH_IOS=`idlcall $PROD_IO _get_patches`
	NUM=`idlarg 1 $PATCH_IOS`
	NUM=`expr "$NUM" + 2 `
	COUNT=2
	while [ "$COUNT" -lt "$NUM" ]
	do
		PATCH_IO=`idlarg $COUNT $PATCH_IOS`
                PATCH_LB=`idlcall $PATCH_IO _get_label`
                PATCH_LB=`eval echo $PATCH_LB`
                IR_PATCH_LB="$PATCH_LB#$IRONAME" 
                wregister -u -r PatchInfo "$IR_PATCH_LB"
		idlcall $PATCH_IO TMF_SysAdmin::PolicyDrivenBase::remove
		COUNT=`expr "$COUNT" + 1 `
	done
	wregister -u -r ProductInfo "$PROD" 
	idlcall $PROD_IO TMF_SysAdmin::PolicyDrivenBase::remove
}
 
remove_NoticeGroup()
{
# work-around to remove Notice groups. The direct remove does not always work
	echo "Removing Notice Groups..." | tee -a $LOG_FILE
	NOTICEGROUP="$1"
	CO=`idlcall $CLO TMF_SysAdmin::Library::lookup_object \"TMF_Notice\" {0}`
	members=`objcall $CO _get_members`
	if [ $? -eq 0 -a -n "$members" ];then
		for i in $members
		do
			LABEL=`idlattr -tg $i label string`
			LABEL=`eval echo "$LABEL"`
			#case "$LABEL" in
			if [ "$LABEL" = "$NOTICEGROUP" ];then
           		echo "     removing Notice Group $LABEL"  | tee -a $LOG_FILE
				idlcall -T top $CO remove_object 'TRUE '$i' '
				Nlabel=`echo $LABEL | awk -F\" '{print $2}'`
				wregister -u -r TMF_Notice "$LABEL"
				objcall $i rmobj
			fi
        done
    fi
} 

remove_TagFiles()
{
	echo "Removing Tag Files..." | tee -a $LOG_FILE

   # remove TAG files to allow re-install
 
	$RM $DBDIR/.installed/RC_ALI_ALIDB
	$RM $DBDIR/.installed/RC_ALI_DB
	$RM $BINDIR/.installed/RC_ALI_BIN
	$RM $EXECDIR/$INTERP/.installed/RC_ALI_BIN
	$RM $EXECDIR/../man/$INTERP/.installed/RC_ALI_MAN
	$RM $EXECDIR/../msg_cat/.installed/RC_ALI_CAT
   $RM $EXECDIR/lcf_bundle/.installed/RC_ALI_LCF

	$RM $DBDIR/.installed/pa_3.6-RCL-0002_ALIDB
	$RM $DBDIR/.installed/pa_3.6-RCL-0003_ALIDB
	$RM $DBDIR/.installed/pa_3.6-RCL-0004_ALIDB
	$RM $DBDIR/.installed/pa_3.6-RCL-0005_ALIDB
	$RM $DBDIR/.installed/pa_3.6-RCL-0012_ALIDB
	$RM $DBDIR/.installed/pa_3.6.1-RCL-0013_ALIDB
	$RM $DBDIR/.installed/pa_3.6.1-RCL-0016_ALIDB
	$RM $BINDIR/.installed/pa_3.6-RCL-0002_BIN
	$RM $BINDIR/.installed/pa_3.6-RCL-0003_BIN
	$RM $BINDIR/.installed/pa_3.6-RCL-0004_BIN
	$RM $BINDIR/.installed/pa_3.6-RCL-0005_BIN
	$RM $BINDIR/.installed/pa_3.6-RCL-0012_BIN
	$RM $BINDIR/.installed/pa_3.6.1-RCL-0013_BIN
	$RM $BINDIR/.installed/pa_3.6.1-RCL-0016_BIN
#	$RM $EXECDIR/$INTERP/.installed/pa_3.6-RCL*
#	$RM $EXECDIR/$INTERP/.installed/pa_3.6.1-RCL*
#	$RM $EXECDIR/../man/$INTERP/.installed/pa_3.6-RCL*
	$RM $EXECDIR/../man/$INTERP/.installed/pa_3.6-RCL-0004_MAN
	$RM $EXECDIR/../man/$INTERP/.installed/pa_3.6.1-RCL*
	$RM $EXECDIR/../msg_cat/.installed/pa_3.6-RCL-0004_CAT
	$RM $EXECDIR/../msg_cat/.installed/pa_3.6.1-RCL*
   $RM $EXECDIR/lcf_bundle/.installed/pa_3.6-RCL-0005_LCF
   $RM $EXECDIR/lcf_bundle/.installed/pa_3.6.1-RCL-0013_LCF

}


remove_lcf()
{
   echo "Removing LCF files" | tee -a $LOG_FILE
   cd $BINDIR/../lcf_bundle
   $RM bin/w32-ix86/TME/PCREMOTE/pctlcf.exe
   $RM bin/win95/TME/PCREMOTE/pctlcf.exe
   $RM bin/win3x/TME/PCREMOTE/pctlcf.exe
   $RM bin/os2-ix86/TME/PCREMOTE/pctlcf.exe
}

remove_bin()
{
   echo "Removing Binaries" | tee -a $LOG_FILE
   cd $BINDIR
	$RM TME/PCREMOTE*
   case "$INTERP" in
   w32-ix86)
      $RM bin/wrcmdpcr.exe
      $RM bin/wrc.exe
      ;;
   aix3-r2|aix4-r1|hpux9|hpux10|solaris2|sunos4)
      $RM bin/wrcmdpcr
      $RM bin/wrc
      ;;
   esac
}

remove_man()
{
   echo "Removing Man pages" | tee -a $LOG_FILE
   if [ "$INTERP" != "w32-ix86" ]; then 
   	cd $TOP/man/"$INTERP"
   	case "$INTERP" in
      	hpux9|hpux10|solaris2)
	      	$RM man1m/wrcmdpcr.1m
	   	;;
      	sunos4|aix3-r2|aix4-r1)
	      	$RM man1/wrcmdpcr.1m
	   	;;
   	esac
   fi
}

remove_cat()
{
   echo "Removing Message Catalogs" | tee -a $LOG_FILE
   cd $TOP/msg_cat
   
   $RM C/AboutRC_ALICatalog.cat
	$RM C/AboutRC_CTL_MCatalog.cat
	$RM C/AboutRC_CTL_PCatalog.cat
	$RM C/AboutRC_TGT_MCatalog.cat
	$RM C/AboutRC_TGT_PCatalog.cat
	$RM C/pcgateway_msg.cat
	$RM C/pcremote_msg.cat
	$RM C/pcrplcf_msg.cat
	$RM C/pctarget_msg.cat

   $RM fr_FR/AboutRC_ALICatalog.cat
	$RM fr_FR/AboutRC_CTL_MCatalog.cat
	$RM fr_FR/AboutRC_CTL_PCatalog.cat
	$RM fr_FR/AboutRC_TGT_MCatalog.cat
	$RM fr_FR/AboutRC_TGT_PCatalog.cat
	$RM fr_FR/pcgateway_msg.cat
	$RM fr_FR/pcremote_msg.cat
	$RM fr_FR/pcrplcf_msg.cat
	$RM fr_FR/pctarget_msg.cat

   $RM ja_JP/AboutRC_ALICatalog.cat
	$RM ja_JP/AboutRC_CTL_MCatalog.cat
	$RM ja_JP/AboutRC_CTL_PCatalog.cat
	$RM ja_JP/AboutRC_TGT_MCatalog.cat
	$RM ja_JP/AboutRC_TGT_PCatalog.cat
	$RM ja_JP/pcgateway_msg.cat
	$RM ja_JP/pcremote_msg.cat
	$RM ja_JP/pcrplcf_msg.cat
	$RM ja_JP/pctarget_msg.cat

   $RM pt_BR/AboutRC_ALICatalog.cat
	$RM pt_BR/AboutRC_CTL_MCatalog.cat
	$RM pt_BR/AboutRC_CTL_PCatalog.cat
	$RM pt_BR/AboutRC_TGT_MCatalog.cat
	$RM pt_BR/AboutRC_TGT_PCatalog.cat
	$RM pt_BR/pcgateway_msg.cat
	$RM pt_BR/pcremote_msg.cat
	$RM pt_BR/pcrplcf_msg.cat
	$RM pt_BR/pctarget_msg.cat

}

remove_db_files()
{
   echo "Removing DB files" | tee -a $LOG_FILE
   cd $DBDIR
   $RM TME/PCREMOTE
}

remove_files()
{
	remove_bin
   remove_db_files
	remove_lcf
	remove_man
#	remove_cat
}

#######################################
# main starts here
#######################################
#set -x
BO=`objcall 0.0.0 self`
if [ -z "$BO" ];then
   echo "You must source in the Tivoli environment and set the"
   echo "logins for the appropriate ManagedNodes administrator"
   echo "to run this command."
   exit 1
fi
OSERV=`objcall $BO getattr oserv`
EXECDIR=`objcall $OSERV query install_dir`
TOP=`dirname $EXECDIR`
DBDIR=`objcall $OSERV query db_dir`
INTERP=`objcall $OSERV query interp`
BINDIR=$EXECDIR/$INTERP
DISP=`echo $OSERV |awk -F. '{print $2}'`
REGION=`echo $OSERV |awk -F. '{print $1}'`
CLO=`wlookup Library`
TNR=`wlookup NameRegistry`
LocalHostOid=`objcall 0.0.0 getattr HostLocation`
NodeNameQ=`idlcall $LocalHostOid SysAdmin::PolicyDrivenBase::_get_label `
NodeName=`eval echo $NodeNameQ`
RM="rm -rf"

#Get the region name to avoid collisions
IRO=`wlookup InterRegion`
IRONAME=`idlattr -t -g $IRO name string`
IRONAME=`eval echo $IRONAME`

INST_CLASSES="RemoteControl controller PCTarget PCGateway PCTplcf PCTlcf RemoteControlPD RemoteControlPV"
ALL_CLASSES="RemoteControl controller PCTarget PCGateway PCTplcf PCTlcf RemoteControlPD RemoteControlPV"
REMOVEFILES="FALSE"
MYUSAGE="FALSE"

if [ "$INTERP" != "w32-ix86" ];then
	LOG_FILE=/tmp/RCALI-R.log  
else
	LOG_FILE=$DBDIR/tmp/RCALI-R.log
fi
echo "Start" | tee $LOG_FILE

# parse command line

for i in "$@"; do
   case "$i" in 
      -rmfiles|-RMFILES)
         REMOVEFILES="TRUE"
      ;;
      -usage|-USAGE)
         MYUSAGE="TRUE"
      ;;
   esac
done

if [ "$MYUSAGE" = "TRUE" ]; then
   echo "RC_ALI-R.sh [-rmfiles] [-usage]" | tee -a $LOG_FILE
   echo "-usage: print this message" | tee -a $LOG_FILE
   echo "-rmfiles: remove files" | tee -a $LOG_FILE
   echo "done" | tee -a $LOG_FILE
   exit 0
fi

#remove_TagFiles 

# determine if this is the TMR server
if [ $DISP -ne 1 ];then
	# if this is a client, we only want to clean up 
	# the local database and remove any local copy
	# profiles

   for i in $INST_CLASSES 
   do
      delete_instance_by_node $i $LocalHostOid
   done

	
	# will remove this node from the ProductInfo and PatchInfo
	# objects, so that Install won't think this node has this application
	# NodeNameQ is the double quoted label of the ManagedNode

	update_ProductInfo "RC_ALI" "$NodeNameQ"

else

   #
   # delete all instances of our classes
   #
        
   for i in $INST_CLASSES
   do
      delete_instance $i
   done   
      
	# for each class that is created, you need to call remove_class.
	# Order matters, so remove the classes in the oposite order that
	# that they were created.
      
   for i in $ALL_CLASSES
   do
      remove_class $i
   done

	
	# This will update/remove tmr and PolicyRegion roles
	# as well as update/remove the roles from all Administrators

   for i in remote_monitor remote_control remote_probe remote_reboot
   do
      echo "Removing " $i " role..." | tee -a $LOG_FILE
      remove_role $i
      echo "Removed." | tee -a $LOG_FILE
   done      

	# this the script that is unique to each application. This is 
	# equivelent to the after script to patchgen. If you do anything
	# special like update inheretance, you will need to undo it here.

	#remove_misc

	# remove_ProductInfo will remove the ProductInfo object and any
	# patches that are associated to it.

	remove_ProductInfo "RC_ALI"

	# remove_NoticeGroup will remove the notice group.

	remove_NoticeGroup "TME 10/Remote Control"
    
   # Put the IR in replace mode for the new irpopulate in next install
   
	#IR=`wlookup InterfaceRepository`
	#idlattr -t -s $IR replace_mode boolean TRUE

   # run wchkdb -u to clean up
	echo "It is recomended that wchkdb -u be run."
	#echo "Would you like to run it now? [y/n]"
	#read ans
	#if [ "$ans" = "y" -o "$ans" = "Y" ];then
	#	wchkdb -u
	#fi
fi

# supply the tag that the product uses. This is the label of the 
# ProductInfo object, or the first field in the IND file.

remove_TagFiles 

# remove_files will need to be filled in with the specific files that
# apply to your application. You can get these files from the CFG files
# of the application image. 

if [ $REMOVEFILES = "TRUE" ]; then
   remove_files
fi 

echo "done" | tee -a $LOG_FILE
exit 0
